package example.bundle;

import java.awt.Desktop;
import java.util.function.Consumer;

import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.ui.IViewSite;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.part.ViewPart;

public class MainView
    extends ViewPart
{
    public static final String ID = MainView.class.getCanonicalName();

    private Label label;

    @Override
    public void init(IViewSite site) throws PartInitException {
        super.init(site);
    }

    @Override
    public void createPartControl(Composite parent) {
        label = new Label(parent, 1);
        label.setLayoutData(new GridData());
        label.setText("No URL received"); //$NON-NLS-1$

        setUrlHandler(url -> parent.getDisplay().asyncExec(() -> label.setText(url)));
    }

    private void setUrlHandler(Consumer<String> handler) {
        Desktop.getDesktop().setOpenURIHandler(openUriEvent -> {
            handler.accept(openUriEvent.getURI().toString());
        });
    }

    @Override
    public void setFocus() {
        // TODO Auto-generated method stub
    }

}
